/*
* Copyright (c) 2015 ETH-Zurich. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/


//#include <config.h>

#define HAVE_MPI_H

#ifndef LIBLSB_H_
#define LIBLSB_H_

#define SYNC_WINDOW

#ifndef HAVE_MPI_IN
#undef SYNC_WINDOW
#endif

#ifdef SYNC_WINDOW
#include <mpi.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

void LSB_Init(const char *projname, int autoprof_interval);
void LSB_Finalize();
void LSB_Reg_param(const char *format, ...);
void LSB_Set_Rparam_int(const char * id, int val);
void LSB_Set_Rparam_string(const char * id, const char * val);
void LSB_Reg_id(const char *format, ...);
void LSB_Rec(unsigned int id);
void LSB_Rec_ints(unsigned int id, int int1, int int2);
void LSB_Rec_intdbl(unsigned int id, int int1, double dbl);
void LSB_Flush();
void LSB_Res();
void LSB_Rec_enable();
void LSB_Rec_disable();

#ifdef SYNC_WINDOW
void LSB_Sync_init_stage1(MPI_Comm comm);
void LSB_Sync_init_stage2(MPI_Comm comm, unsigned long long *win);
long LSB_Sync(unsigned long long win);
#endif



#ifdef __cplusplus
}
#endif
#endif /* LIBLSB_H_ */
